Index: cards/delphes_card_IDEAtrkCov.tcl
===================================================================
--- cards/delphes_card_IDEAtrkCov.tcl	(revision 31f3bcaa997a74c48dab1adc75637db03788b7d3)
+++ cards/delphes_card_IDEAtrkCov.tcl	(revision 31f3bcaa997a74c48dab1adc75637db03788b7d3)
@@ -0,0 +1,609 @@
+####################################################################                                l
+# FCC-ee IDEA detector model                                                                                      
+#                                                                                                    
+# Authors: Elisa Fontanesi, Lorenzo Pezzotti, Massimiliano Antonello                                 
+# email: efontane@bo.infn.it,
+#        lorenzo.pezzotti01@universitadipavia.it,                                                    
+#        m.antonello@uninsubria.it,                                                                  
+#####################################################################                                
+#       
+#######################################
+# Order of execution of various modules
+#######################################
+
+set ExecutionPath {
+  ParticlePropagator
+
+  ChargedHadronTrackingEfficiency
+  ElectronTrackingEfficiency
+  MuonTrackingEfficiency
+
+  TrackMergerPre
+  TrackSmearing
+
+  TrackMerger 
+  Calorimeter
+  EFlowMerger
+
+  PhotonEfficiency
+  PhotonIsolation
+
+  ElectronFilter
+  ElectronEfficiency
+  ElectronIsolation
+
+  MuonEfficiency
+  MuonIsolation
+
+  MissingET
+
+  NeutrinoFilter
+  GenJetFinder
+  GenMissingET
+  
+  FastJetFinder
+
+  JetEnergyScale
+
+  JetFlavorAssociation
+
+  BTagging
+  TauTagging
+
+  UniqueObjectFinder
+
+  ScalarHT
+  TreeWriter
+}
+
+
+#################################
+# Propagate particles in cylinder
+#################################
+
+module ParticlePropagator ParticlePropagator {
+  set InputArray Delphes/stableParticles
+
+  set OutputArray stableParticles
+  set ChargedHadronOutputArray chargedHadrons
+  set ElectronOutputArray electrons
+  set MuonOutputArray muons
+
+  # inner radius of the solenoid, in m
+  set Radius 2.25
+
+  # half-length: z of the solenoid, in m
+  set HalfLength 2.5
+
+  # magnetic field, in T
+  set Bz 2.0
+}
+
+####################################
+# Charged hadron tracking efficiency
+####################################
+
+module Efficiency ChargedHadronTrackingEfficiency {
+    set InputArray ParticlePropagator/chargedHadrons
+    set OutputArray chargedHadrons
+    # We use only one efficiency, we set only 0 effincency out of eta bounds:
+
+    set EfficiencyFormula {
+        (abs(eta) > 3.0)                                       * (0.000) +
+        (energy >= 0.5) * (abs(eta) <= 3.0)                    * (0.997) +
+        (energy < 0.5 && energy >= 0.3) * (abs(eta) <= 3.0)    * (0.65) +
+        (energy < 0.3) * (abs(eta) <= 3.0)                     * (0.06)
+    }
+}
+
+#	(pt <= 0.1)                                     * (0.00) + 
+#	(abs(eta) <= 3.0)               * (pt > 0.1)    * (1.00) +
+#	(abs(eta) > 3)                                  * (0.00)
+
+
+
+##############################
+# Electron tracking efficiency
+##############################
+
+module Efficiency ElectronTrackingEfficiency {
+    set InputArray ParticlePropagator/electrons
+    set OutputArray electrons
+
+
+    # Current full simulation with CLICdet provides for electrons:
+    set EfficiencyFormula {
+        (abs(eta) > 3.0)                                       * (0.000) +
+        (energy >= 0.5) * (abs(eta) <= 3.0)                    * (0.997) +
+        (energy < 0.5 && energy >= 0.3) * (abs(eta) <= 3.0)    * (0.65) +
+        (energy < 0.3) * (abs(eta) <= 3.0)                     * (0.06)
+    } 
+}
+
+
+##########################
+# Muon tracking efficiency
+##########################
+
+module Efficiency MuonTrackingEfficiency {
+    set InputArray ParticlePropagator/muons
+    set OutputArray muons
+
+    # Current full simulation with CLICdet provides for muons:
+    set EfficiencyFormula {
+        (abs(eta) > 3.0)                                       * (0.000) +
+        (energy >= 0.5) * (abs(eta) <= 3.0)                    * (0.997) +
+        (energy < 0.5 && energy >= 0.3) * (abs(eta) <= 3.0)    * (0.65) +
+        (energy < 0.3) * (abs(eta) <= 3.0)                     * (0.06)
+    }
+}
+
+##############
+# Track merger
+##############
+
+module Merger TrackMergerPre {
+# add InputArray InputArray
+  add InputArray ChargedHadronTrackingEfficiency/chargedHadrons
+  add InputArray ElectronTrackingEfficiency/electrons
+  add InputArray MuonTrackingEfficiency/muons
+  set OutputArray tracks
+}
+
+
+########################################
+# Smearing for charged tracks
+########################################
+
+module TrackCovariance TrackSmearing {
+    set InputArray TrackMergerPre/tracks
+    set OutputArray tracks
+
+    set DetectorGeometry GeoIDEA_BASE.txt
+    set Bz 2.0
+
+}
+
+
+##############
+# Track merger
+##############
+
+module Merger TrackMerger {
+# add InputArray InputArray
+  add InputArray TrackCovariance/tracks
+  set OutputArray tracks
+}
+
+
+#############                                                                                                                         
+# Calorimeter                                                                                                                                            
+#############                                                                                                                                           
+module DualReadoutCalorimeter Calorimeter {
+  set ParticleInputArray ParticlePropagator/stableParticles
+  set TrackInputArray TrackMerger/tracks
+
+  set TowerOutputArray towers
+  set PhotonOutputArray photons
+
+  set EFlowTrackOutputArray eflowTracks
+  set EFlowPhotonOutputArray eflowPhotons
+  set EFlowNeutralHadronOutputArray eflowNeutralHadrons
+
+  set ECalEnergyMin 0.5
+  set HCalEnergyMin 0.5
+  set EnergyMin 0.5
+  set ECalEnergySignificanceMin 1.0
+  set HCalEnergySignificanceMin 1.0
+  set EnergySignificanceMin 1.0
+
+  set SmearTowerCenter true
+    set pi [expr {acos(-1)}]
+
+    # Lists of the edges of each tower in eta and phi;                                                                                            
+    # each list starts with the lower edge of the first tower;                                                                                                    
+    # the list ends with the higher edged of the last tower.                                                                                        
+    # Barrel:  deta=0.02 towers up to |eta| <= 0.88 ( up to 45Â°)                                                                                        
+    # Endcaps: deta=0.02 towers up to |eta| <= 3.0 (8.6Â° = 100 mrad)                                                                                           
+    # Cell size: about 6 cm x 6 cm                                                  
+
+    #barrel:                                                                                        
+    set PhiBins {}
+    for {set i -120} {$i <= 120} {incr i} {
+        add PhiBins [expr {$i * $pi/120}]
+    }
+    #deta=0.02 units for |eta| <= 0.88                                                              
+    for {set i -44} {$i < 45} {incr i} {
+        set eta [expr {$i * 0.02}]
+        add EtaPhiBins $eta $PhiBins
+    }
+
+    #endcaps:                                                                                       
+    set PhiBins {}
+    for {set i -120} {$i <= 120} {incr i} {
+        add PhiBins [expr {$i* $pi/120}]
+    }
+    #deta=0.02 units for 0.88 < |eta| <= 3.0                                                        
+    #first, from -3.0 to -0.88                                                                      
+    for {set i 1} {$i <=106} {incr i} {
+        set eta [expr {-3.00 + $i * 0.02}]
+        add EtaPhiBins $eta $PhiBins
+    }
+    #same for 0.88 to 3.0                                                                           
+    for  {set i 1} {$i <=106} {incr i} {
+        set eta [expr {0.88 + $i * 0.02}]
+        add EtaPhiBins $eta $PhiBins
+    }
+
+    # default energy fractions {abs(PDG code)} {Fecal Fhcal}                                                                                  
+    add EnergyFraction {0} {0.0 1.0}
+    # energy fractions for e, gamma and pi0                                                                                                           
+    add EnergyFraction {11} {1.0 0.0}
+    add EnergyFraction {22} {1.0 0.0}
+    add EnergyFraction {111} {1.0 0.0}
+    # energy fractions for muon, neutrinos and neutralinos                                                                             
+    add EnergyFraction {12} {0.0 0.0}
+    add EnergyFraction {13} {0.0 0.0}
+    add EnergyFraction {14} {0.0 0.0}
+    add EnergyFraction {16} {0.0 0.0}
+    add EnergyFraction {1000022} {0.0 0.0}
+    add EnergyFraction {1000023} {0.0 0.0}
+    add EnergyFraction {1000025} {0.0 0.0}
+    add EnergyFraction {1000035} {0.0 0.0}
+    add EnergyFraction {1000045} {0.0 0.0}
+    # energy fractions for K0short and Lambda                                                                                                            
+    add EnergyFraction {310} {0.3 0.7}
+    add EnergyFraction {3122} {0.3 0.7}
+
+
+    # set ECalResolutionFormula {resolution formula as a function of eta and energy}                                
+    set ECalResolutionFormula {
+    (abs(eta) <= 0.88 )                     * sqrt(energy^2*0.01^2 + energy*0.11^2)+
+    (abs(eta) > 0.88 && abs(eta) <= 3.0)    * sqrt(energy^2*0.01^2 + energy*0.11^2)
+    }
+
+    # set HCalResolutionFormula {resolution formula as a function of eta and energy}                                                
+    set HCalResolutionFormula {
+    (abs(eta) <= 0.88 )                     * sqrt(energy^2*0.01^2 + energy*0.30^2)+
+    (abs(eta) > 0.88 && abs(eta) <= 3.0)    * sqrt(energy^2*0.01^2 + energy*0.30^2)
+    }
+}
+
+####################
+# Energy flow merger
+####################
+
+module Merger EFlowMerger {
+# add InputArray InputArray
+  add InputArray Calorimeter/eflowTracks
+  add InputArray Calorimeter/eflowPhotons
+  add InputArray Calorimeter/eflowNeutralHadrons
+  set OutputArray eflow
+}
+
+###################
+# Photon efficiency
+###################
+
+module Efficiency PhotonEfficiency {
+  set InputArray Calorimeter/eflowPhotons
+  set OutputArray photons
+
+  # set EfficiencyFormula {efficiency formula as a function of eta and pt}
+  # efficiency formula for photons
+  set EfficiencyFormula {
+        (energy < 2.0)                                        * (0.000)+
+        (energy >= 2.0) * (abs(eta) <= 0.88)                  * (0.99) +
+        (energy >= 2.0) * (abs(eta) >0.88 && abs(eta) <= 3.0) * (0.99) +
+        (abs(eta) > 3.0)                                      * (0.000)
+  }
+}
+
+##################
+# Photon isolation
+##################
+
+module Isolation PhotonIsolation {
+  set CandidateInputArray PhotonEfficiency/photons
+  set IsolationInputArray EFlowMerger/eflow
+
+  set OutputArray photons
+
+  set DeltaRMax 0.5
+
+  set PTMin 0.5
+
+  set PTRatioMax 999.
+}
+
+#################
+# Electron filter
+#################
+
+module PdgCodeFilter ElectronFilter {
+  set InputArray Calorimeter/eflowTracks
+  set OutputArray electrons
+  set Invert true
+  add PdgCode {11}
+  add PdgCode {-11}
+}
+
+#####################
+# Electron efficiency
+#####################
+
+module Efficiency ElectronEfficiency {
+  set InputArray ElectronFilter/electrons
+  set OutputArray electrons
+
+  # set EfficiencyFormula {efficiency formula as a function of eta and pt}
+
+  # efficiency formula for electrons
+  set EfficiencyFormula {          
+        (energy < 2.0)                                         * (0.000)+
+        (energy >= 2.0) * (abs(eta) <= 0.88)                   * (0.99) +
+        (energy >= 2.0) * (abs(eta) >0.88 && abs(eta) <= 3.0)  * (0.99) +
+        (abs(eta) > 3.0)                                       * (0.000)
+  }
+}
+
+####################
+# Electron isolation
+####################
+
+module Isolation ElectronIsolation {
+  set CandidateInputArray ElectronEfficiency/electrons
+  set IsolationInputArray EFlowMerger/eflow
+
+  set OutputArray electrons
+
+  set DeltaRMax 0.5
+
+  set PTMin 0.5
+
+  set PTRatioMax 0.12
+}
+
+#################
+# Muon efficiency
+#################
+
+module Efficiency MuonEfficiency {
+  set InputArray MuonMomentumSmearing/muons
+  set OutputArray muons
+
+  # set EfficiencyFormula {efficiency as a function of eta and pt}
+
+  # efficiency formula for muons
+  set EfficiencyFormula {                                   
+        (energy < 2.0)                                         * (0.000)+
+        (energy >= 2.0) * (abs(eta) <= 0.88)                   * (0.99) +
+        (energy >= 2.0) * (abs(eta) >0.88 && abs(eta) <= 3.0)  * (0.99) +
+        (abs(eta) > 3.0)                                       * (0.000)
+  }
+}
+
+################
+# Muon isolation
+################
+
+module Isolation MuonIsolation {
+  set CandidateInputArray MuonEfficiency/muons
+  set IsolationInputArray EFlowMerger/eflow
+
+  set OutputArray muons
+
+  set DeltaRMax 0.5
+
+  set PTMin 0.5
+
+  set PTRatioMax 0.25
+}
+
+###################
+# Missing ET merger
+###################
+
+module Merger MissingET {
+# add InputArray InputArray
+  add InputArray EFlowMerger/eflow
+  set MomentumOutputArray momentum
+}
+
+##################
+# Scalar HT merger
+##################
+
+module Merger ScalarHT {
+# add InputArray InputArray
+  add InputArray UniqueObjectFinder/jets
+  add InputArray UniqueObjectFinder/electrons
+  add InputArray UniqueObjectFinder/photons
+  add InputArray UniqueObjectFinder/muons
+  set EnergyOutputArray energy
+}
+
+#####################
+# Neutrino Filter
+#####################
+
+module PdgCodeFilter NeutrinoFilter {
+
+  set InputArray Delphes/stableParticles
+  set OutputArray filteredParticles
+
+  set PTMin 0.0
+
+  add PdgCode {12}
+  add PdgCode {14}
+  add PdgCode {16}
+  add PdgCode {-12}
+  add PdgCode {-14}
+  add PdgCode {-16}
+}
+
+
+#####################
+# MC truth jet finder
+#####################
+
+module FastJetFinder GenJetFinder {
+  set InputArray NeutrinoFilter/filteredParticles
+
+  set OutputArray jets
+
+  # algorithm: 1 CDFJetClu, 2 MidPoint, 3 SIScone, 4 kt, 5 Cambridge/Aachen, 6 antikt
+  set JetAlgorithm 6
+  set ParameterR 0.4
+  set JetPTMin 1.0
+}
+
+
+#########################
+# Gen Missing ET merger
+########################
+
+module Merger GenMissingET {
+# add InputArray InputArray
+  add InputArray NeutrinoFilter/filteredParticles
+  set MomentumOutputArray momentum
+}
+
+############
+# Jet finder
+############
+
+module FastJetFinder FastJetFinder {
+#  set InputArray Calorimeter/towers
+  set InputArray EFlowMerger/eflow
+
+  set OutputArray jets
+
+  # algorithm: 1 CDFJetClu, 2 MidPoint, 3 SIScone, 4 kt, 5 Cambridge/Aachen, 6 antikt
+  set JetAlgorithm 6
+  set ParameterR 0.4
+  set JetPTMin 1.0
+}
+
+##################
+# Jet Energy Scale
+##################
+
+module EnergyScale JetEnergyScale {
+  set InputArray FastJetFinder/jets
+  set OutputArray jets
+
+  # scale formula for jets
+  set ScaleFormula {1.08}
+}
+
+########################
+# Jet Flavor Association
+########################
+
+module JetFlavorAssociation JetFlavorAssociation {
+
+  set PartonInputArray Delphes/partons
+  set ParticleInputArray Delphes/allParticles
+  set ParticleLHEFInputArray Delphes/allParticlesLHEF
+  set JetInputArray JetEnergyScale/jets
+
+  set DeltaR 0.5
+  set PartonPTMin 1.0
+  set PartonEtaMax 3.0
+}
+
+###########
+# b-tagging
+###########
+
+module BTagging BTagging {
+  set JetInputArray JetEnergyScale/jets
+
+  set BitNumber 0
+
+  # add EfficiencyFormula {abs(PDG code)} {efficiency formula as a function of eta and pt}
+  
+  # default efficiency formula (misidentification rate)
+  add EfficiencyFormula {0} {0.01}
+
+  # efficiency formula for c-jets (misidentification rate)
+  add EfficiencyFormula {4} {0.10}
+
+  # efficiency formula for b-jets
+  add EfficiencyFormula {5} {0.80}
+}
+
+#############
+# tau-tagging
+#############
+
+module TauTagging TauTagging {
+  set ParticleInputArray Delphes/allParticles
+  set PartonInputArray Delphes/partons
+  set JetInputArray JetEnergyScale/jets
+
+  set DeltaR 0.5
+  set TauPTMin 1.0
+  set TauEtaMax 3.0
+
+  # default efficiency formula (misidentification rate)
+  add EfficiencyFormula {0} {0.001}
+  # efficiency formula for tau-jets
+  add EfficiencyFormula {15} {0.6}
+}
+
+
+#####################################################
+# Find uniquely identified photons/electrons/tau/jets
+#####################################################
+
+module UniqueObjectFinder UniqueObjectFinder {
+# earlier arrays take precedence over later ones
+# add InputArray InputArray OutputArray
+  add InputArray PhotonIsolation/photons photons
+  add InputArray ElectronIsolation/electrons electrons
+  add InputArray MuonIsolation/muons muons
+  add InputArray JetEnergyScale/jets jets
+}
+
+
+
+##################
+# ROOT tree writer
+##################
+
+# Tracks, towers and eflow objects are not stored by default in the output.
+# If needed (for jet constituent or other studies), uncomment the relevant
+# "add Branch ..." lines.
+
+module TreeWriter TreeWriter {
+    # add Branch InputArray BranchName BranchClass
+    
+    add Branch Delphes/allParticles Particle GenParticle
+
+    add Branch TrackMerger/tracks Track Track
+    add Branch Calorimeter/towers Tower Tower
+    
+    add Branch Calorimeter/eflowTracks EFlowTrack Track
+    add Branch Calorimeter/eflowPhotons EFlowPhoton Tower
+    add Branch Calorimeter/eflowNeutralHadrons EFlowNeutralHadron Tower
+
+    add Branch Calorimeter/photons CaloPhoton Photon
+    add Branch PhotonEfficiency/photons PhotonEff Photon
+    add Branch PhotonIsolation/photons PhotonIso Photon
+    
+    add Branch GenJetFinder/jets GenJet Jet
+    add Branch GenMissingET/momentum GenMissingET MissingET
+    
+    add Branch UniqueObjectFinder/jets Jet Jet
+    add Branch UniqueObjectFinder/electrons Electron Electron
+    add Branch UniqueObjectFinder/photons Photon Photon
+    add Branch UniqueObjectFinder/muons Muon Muon
+    
+    add Branch JetEnergyScale/jets AntiKtJet Jet  
+    
+    add Branch MissingET/momentum MissingET MissingET
+    add Branch ScalarHT/energy ScalarHT ScalarHT
+}
+